package com.malk.repository.entity.primary;

import com.malk.base.BasePo;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Range;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

/**
 * 宜搭授权信息类
 **/
@Entity
@Data
@NoArgsConstructor
@Table(name = "mc_authorization")
public class McAuthorizationPo extends BasePo {

    @Range(min = 0, max = 1)
    private int delStatus = 0; // 是否删除: 设置默认值

    @NotNull(message = "应用编码不能为空")
    private String appType;

    @NotNull(message = "应用秘钥不能为空")
    private String systemToken;

    @NotNull(message = "应用名称不能为空")
    private String appName;

    @NotNull(message = "授权企业编号不能为空")
    private String corpId;

    private String corpName;

    @NotNull(message = "申请人用户编号不能为空")
    private String userId;

    @NotNull(message = "申请人姓名不能为空")
    private String userName;

    private String deptId;

    private String deptName;

    private String description;

    private String remark;
}
