package com.malk.server.ekuaibao;

import cn.hutool.core.util.ObjectUtil;
import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class EKBR extends VenR {

    private String errorCode;

    private String errorMessage;

    /**
     * 返回数据
     */
    private List<Map> items;

    /**
     * 单据详情
     */
    private Map value;

    /**
     * 创建单据
     */
    Map flow;

    int type;

    /**
     * 单据数量
     */
    long count;

    // 成功状态标记
    private final static String SUC_CODE = "0";

    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(ObjectUtil.isNotNull(errorCode) && !errorCode.equals(SUC_CODE), errorCode, errorMessage, "ekuaibao");
    }
}

