package com.malk.server.xbongbong;


import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * 读取配置文件参考FilePah
 */
@Data
@Component
@ConfigurationProperties(prefix = "xbongbong")
public class XBBConf {

    /**
     * 公司corpid。接口基础参数，接口请求必传
     */
    private String corpid;


    /**
     * 访问接口的token,该值相当于密钥
     * 管理员账号登录销帮帮WEB版后台后，访问https://pfweb.xbongbong.com/#/apiToken/index查看
     */
    private String token;

    /**
     * 接口操作人userId,接口基础参数。不传默认取超管角色
     */
    private String userId;

    /**
     * 回调解析token
     */
    private String callbackToken;

    /**
     * 销帮帮接口根域名
     */
    public static final String platformApi = "https://proapi.xbongbong.com";
}
