package com.malk.service.dingtalk;

import java.util.List;
import java.util.Map;

public interface DDClient_Attendance {

    /**
     * 获取打卡结果
     *
     * @param userIdList   企业内的员工ID列表，最大值50;
     * @param workDateFrom 和workDateTo参数相隔最多7天（包含7天）; 格式为“yyyy-MM-dd HH:mm:ss”，HH:mm:ss可以使用00:00:00，将返回此日期从0点到24点的结果
     * @param offset       表示获取考勤数据的起始点, 下次获取传的offset值为之前的offset+limit; 表示获取考勤数据的条数，最大值50。
     */
    List<Map> listAttendanceResult(String access_token, String[] userIdList, String workDateFrom, String workDateTo, Number offset, Number size);

    /**
     * 获取打卡详情
     *
     * @apiNote https://open.dingtalk.com/document/orgapp/attendance-clock-in-record-is-open
     */
    List<Map> listAttendanceRecord(String access_token, List userIds, String checkDateFrom, String checkDateTo);

    /**
     * 上传打卡记录 [Notice]
     * -
     * 1. 接口已下架, 需要开通专业版联系官方开权限
     * 2. 不是userId, 也可请求成功, 但无数据写入
     * 3. 考勤会以接口写入为准, 如已存在18点打卡, 再写入14点记录, 显示早退
     */
    boolean uploadAttendanceRecord(String access_token, String userId, String deviceName, String deviceId, String photoUrl, long userCheckTime);

    /**
     * 查询假期余额 [分页是根据游标控制]
     *
     * @param op_userid  当前企业内拥有OA审批应用权限的管理员的userId
     * @param leave_code 假期类型唯一标识 [查询假期规则列表]
     * @param userids    待查询的员工ID列表, 半角逗号相隔
     * @param offset     分页偏移，从0开始的非负整数
     * @param size       分页偏移，最大50
     */
    List<Map> queryVacationQuota(String access_token, String op_userid, String leave_code, String userids, int offset, int size);

    /**
     * 查询假期余额_全部
     */
    List<Map> queryVacationQuota_all(String access_token, String op_userid, String leave_code, String userids, int offset, int size);
}
