package com.malk.service.xbongbong.impl;

import com.alibaba.fastjson.JSON;
import com.malk.server.common.VenR;
import com.malk.server.xbongbong.DigestUtil;
import com.malk.server.xbongbong.XBBConf;
import com.malk.server.xbongbong.XBBR;
import com.malk.service.xbongbong.XBBClient;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Slf4j
@Service
public class XBBImplClient implements XBBClient {

    @Autowired
    private XBBConf xbbConf;

    /**
     * 获取签名 [字符]
     */
    public static String getDataSign(Map data, String token) {
        return getDataSign(JSON.toJSONString(data), token);
    }

    /**
     * 获取签名 [字典]
     */
    public static String getDataSign(String data, String token) {
        return DigestUtil.Encrypt(data + token, "SHA-256");
    }

    @Override
    public String getAccessToken(Map data) {
        String sign = getDataSign(data, xbbConf.getToken());

        Map body = UtilMap.map("corpid", xbbConf.getCorpid(), "saasMark", 1, "formId", 864836, "businessType", 100);
        Map header = UtilMap.map("sign", sign);
        XBBR xbbr = (XBBR) XBBR.doPost("https://proapi.xbongbong.com/pro/v2/api/form/get", header, null, body, VenR.RC_XBB);
        return null;
    }
}
