package com.malk.utils;

import javax.annotation.Nullable;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.text.SimpleDateFormat;
import java.util.Date;

public abstract class UtilFile {

    /**
     * 匹配路径: 自动追加年月日作为目录
     * -
     * 文件上传存储,必须是绝对路径. 日志的配置地址可以是相对路径
     */
    public static File mkdirIfNot(@Nullable String fileName, @Nullable String dirName) {
        String date = new SimpleDateFormat("yyyy-MM-dd").format(new Date());
        String outputFile = dirName + "/" + date + "/" + fileName;
        File file = new File(outputFile);
        // 创建 mkdirIfNot
        if (!file.getParentFile().exists()) {
            file.getParentFile().mkdirs();
        }
        return file;
    }

    /**
     * 文件转化为byte字节数组
     */
    public static byte[] fileConvertToByteArray(File file) {
        byte[] data = null;
        try {
            FileInputStream fis = new FileInputStream(file);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            int len;
            byte[] buffer = new byte[1024];
            while ((len = fis.read(buffer)) != -1) {
                baos.write(buffer, 0, len);
            }
            data = baos.toByteArray();
            fis.close();
            baos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }
}
