package com.malk.utils;

import cn.hutool.core.util.ObjectUtil;

import java.util.List;

public abstract class UtilList {

    // 访问安全, 避免空指针访问访问属性异常
    public static boolean isEmpty(List list) {
        return ObjectUtil.isNull(list) || list.isEmpty();
    }

    public static boolean isNotEmpty(List list) {
        return !isEmpty(list);
    }

    public static boolean isEmpty(Object[] list) {
        return ObjectUtil.isNull(list) || list.length == 0;
    }

    public static boolean isNotEmpty(Object[] list) {
        return !isEmpty(list);
    }

    public static Object getLast(List list) {
        if (isEmpty(list)) return null;
        return list.get(list.size() - 1);
    }

    public static Object getLast(Object[] list) {
        if (isEmpty(list)) return null;
        return list[list.length - 1];
    }
}
