### frp

1. `uname -a`    查看服务器版本，下载对应的 [客户端](https://github.com/fatedier/frp/releases)

2. 开放服务器3个端口：1001 绑定映射关系，1002 作为 dashboard 访问看板， 1003 作为ip入口

3. 1003：更建议配置nginx转发, 无需开端口，且方便实现https访问；**将原服务 `api` 改为 `frp`，即可实现转发**

   ```
   # proxy
   location ~ ^/frp/ {
       rewrite  ^/frp/(.*)$  /api/$1  break;
       proxy_pass http://127.0.0.1:1003;
       proxy_set_header Host $host:$server_port;
       proxy_set_header X-Real-IP $remote_addr;
       proxy_set_header Remote_Addr $remote_addr;
       proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
       proxy_set_header X-Forwarded-Proto $scheme;
       proxy_set_header Referer $http_referer;
       client_max_body_size 100m;
       client_body_buffer_size 20480k;
       proxy_send_timeout 300s;
       proxy_read_timeout 300s;
   }
   ```

4. 启动

   进入对应的frp目录，服务器端执行：./frps -c ./frpc.ini ； 客户端执行：./frpc -c ./frpc.ini

    - server 启动

   ```
   cd /home/mc/frp
   # 临时启动
   ./frps -c ./frps.ini
   # 后台启动 [开启日志]
   nohup ./frps -c ./frps.ini  &
   ```

    - local 启动：

   ```
   cd /Users/malk/server/_Tool/proxy/frp
   ./frpc -c ./frpc.ini
   ```

    - hpe 启动

   ```
   cd /home/frp
   ./frpc -c ./frpc.ini
   ```

5. 通过 **http** 访问 dashboard：`http://47.97.181.40:1002/static/#/proxies/tcp`


6. 客户端可通过 sh 快速执行启动 【**frpc.sh**】

```
cd /Users/malk/server/_Tool/proxy/frp
./frpc -c ./frpc.ini
```